@echo off
setlocal

echo ************************************************
echo BOUSI-PROLOG source v3.6.1 uninstallation script
echo ************************************************

rem Gets the full path where this batch file is located
set SCRIPTDIR=%~dp0
set SCRIPTDIR=%SCRIPTDIR:~,-1%

rem Gets the Bousi-Prolog installation directory
set INSTALLDIR=%SCRIPTDIR%


rem Asks for confirmation before starting the uninstallation
echo.
echo Bousi-Prolog is currently installed at %INSTALLDIR%
echo Make sure that you have write access to the installation directory.
:ConfirmUninstallLoop
set OPTION=
set /p OPTION="All contents of this directory will be erased. Do you want to continue (Y/N)? "
if "%OPTION%"=="Y" goto StartUninstall
if "%OPTION%"=="y" goto StartUninstall
if "%OPTION%"=="N" goto CancelUninstall
if "%OPTION%"=="n" goto CancelUninstall
goto ConfirmUninstallLoop


:StartUninstall

rem Erases some files and folders of the directory where the program is
rem installed (the full folder is removed at the end of the batch file)
echo.
echo Erasing %INSTALLDIR%...
rmdir /q /s "%INSTALLDIR%\source"
rmdir /q /s "%INSTALLDIR%\extern"
rmdir /q /s "%INSTALLDIR%\test"
rmdir /q /s "%INSTALLDIR%\doc"
set DELETEFULLDIR=1

rem Deletes the shortcuts created by the installer
echo.
echo Deleting shortcuts from the Start Menu...
for /F "tokens=* delims= " %%A in ('cscript /Nologo "%SCRIPTDIR%\scripts\folder.vbs" Programs') do (
	set PROGRAMSFOLDER=%%A
)
for /F "tokens=* delims= " %%A in ('cscript /Nologo "%SCRIPTDIR%\scripts\folder.vbs" AllUsersPrograms') do (
	set ALLUSERSPROGRAMSFOLDER=%%A
)
if not exist "%PROGRAMSFOLDER%\Bousi-Prolog" goto SkipUserShortcuts
rem Deletes the shortcuts from the "<user>\Start Menu\Programs" folder
del "%PROGRAMSFOLDER%\Bousi-Prolog\Run Bousi-Prolog.lnk" 2> nul
del "%PROGRAMSFOLDER%\Bousi-Prolog\Build Bousi-Prolog.lnk" 2> nul
del "%PROGRAMSFOLDER%\Bousi-Prolog\Open Bousi-Prolog directory.lnk" 2> nul
del "%PROGRAMSFOLDER%\Bousi-Prolog\Uninstall Bousi-Prolog.lnk" 2> nul
rmdir "%PROGRAMSFOLDER%\Bousi-Prolog" 2> nul
:SkipUserShortcuts
if not exist "%ALLUSERSPROGRAMSFOLDER%\Bousi-Prolog" goto SkipAllUsersShortcuts
rem Deletes the shortcuts from the "All Users\Start Menu\Programs" folder
del "%ALLUSERSPROGRAMSFOLDER%\Bousi-Prolog\Run Bousi-Prolog.lnk" 2> nul
del "%ALLUSERSPROGRAMSFOLDER%\Bousi-Prolog\Build Bousi-Prolog.lnk" 2> nul
del "%ALLUSERSPROGRAMSFOLDER%\Bousi-Prolog\Open Bousi-Prolog directory.lnk" 2> nul
del "%ALLUSERSPROGRAMSFOLDER%\Bousi-Prolog\Uninstall Bousi-Prolog.lnk" 2> nul
rmdir "%ALLUSERSPROGRAMSFOLDER%\Bousi-Prolog" 2> nul
:SkipAllUsersShortcuts

rem Shows the results of the uninstallation
echo.
echo Bousi-Prolog has been uninstalled.
goto End


:CancelUninstall

rem Cancels uninstallation
echo.
echo Bousi-Prolog has NOT been uninstalled.
goto End


:End

echo.
echo Press any key to exit the uninstallation script.
pause > nul

rem If the uninstallation was successful, deletes the files used by the
rem uninstaller and the remaining files of the installation directory
if not defined DELETEFULLDIR exit
rmdir /q /s "%INSTALLDIR%\scripts"
rmdir /q /s "%INSTALLDIR%"

